/****************************************Copyright (c)****************************************************
**                            Guangzhou ZLGMCU Development Co., LTD
**
**                                 http://www.zlgmcu.com
**
**--------------File Info---------------------------------------------------------------------------------
** File name:           main.c
** Last modified Date:  2016-6-06
** Last Version:        V1.01
** Descriptions:         
**
**--------------------------------------------------------------------------------------------------------
** Created by:          yanghongyu
** Created date:        2015-6-06
** Version:             V1.00
** Descriptions:         
**
**--------------------------------------------------------------------------------------------------------
** Modified by:         heyuanfeng
** Modified date:       2016-6-06
** Version:             V1.01
** Descriptions:         
*********************************************************************************************************/
#include "LPC11xx.h"                                                    /* LPC11xxĴ            */
#include "uart.h" 

#include "stdint.h"

#include "SX1212Driver.h"
/*********************************************************************************************************
  궨
*********************************************************************************************************/
#define LED_INIT()    LPC_GPIO2->DIR  |=  0XFF0                         /* LEDʼ                    */

void SendRfFrame(_U8 *buffer, _U8 size, _U8 *pReturnCode);
void SX1276LoRaSetSpreadingFactor( uint8_t factor );

extern uint16_t   uiByteNum;    	    	    	    	            /*  ڽݸ            */

uint8_t   ucRxbuf[PACK_LENGTH]  = {0};                                  /*  ݻ              */
uint8_t   ucTxbuf[PACK_LENGTH] = {0};                                   /*  ݻ洮ڻ    */
uint16_t  uiMs          = 0; 

static uint8_t    ucsleep  = 0;
static uint8_t    led  = 0;
static uint8_t    UPwr = 0;                                             /*  书,С5dBm,20dBm */

/*********************************************************************************************************
** Function name:        LED_Show
** Descriptions:         
** input parameters:     ucled 
** output parameters:    
*********************************************************************************************************/
void LED_Show(unsigned char ucled)
{

    unsigned int temp = 0;
    
     /* ȵIO˳,ٸֵ */
    temp |= (ucled & (1ul << 7)) >> 5;   /* LED7,DIO6 */
    temp |= (ucled & (1ul << 6)) >> 3;   /* LED6,DIO7 */
    temp |= (ucled & (1ul << 5)) >> 1;   /* LED5,DIO8 */    
    temp |= (ucled & (1ul << 4)) >> 4;   /* LED4,DIO4 */
    temp |= (ucled & (1ul << 3)) >> 2;   /* LED3,DIO5 */    
    temp |= (ucled & (1ul << 2)) << 3;   /* LED2,DIO9 */
    temp |= (ucled & (1ul << 1)) << 5;   /* LED1,DIO10 */    
    temp |= (ucled & (1ul << 0)) << 7;   /* LED0,DIO11 */
    
    LPC_GPIO2->DATA &= 0x00f;
    LPC_GPIO2->DATA |= ~(temp << 4);
}
/*********************************************************************************************************
** Function name:        dellayms
** Descriptions:         
** input parameters:     uiNum: 
** output parameters:    
*********************************************************************************************************/
void dellayxms(unsigned int uiNum)
{
   unsigned int i = 0;
   unsigned int j = 0;
   while(i < uiNum) {
       	 i++;
    	 for(j = 0; j < 4369; j++);
   }
}
/*********************************************************************************************************
** Function name:       KEY2_INT
** Descriptions:        S2Ӧжϳʼ
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void KEY2_INT (void)
{
    LPC_GPIO1->DIR &= ~ (1ul << 2);                                     /*  P1.2Ϊ              */
    LPC_GPIO1->IS   = 0x00;                                             /*  P1.2Ϊж              */
    LPC_GPIO1->IEV &= (1ul << 2);                                       /*  ½ж                  */
    LPC_GPIO1->IE  |= (1ul << 2);                                       /*  P1.2жϲ              */    	
    NVIC_EnableIRQ(EINT1_IRQn);                                         /* жϲʹ               */
    NVIC_SetPriority(EINT1_IRQn, 2);    
}
/*********************************************************************************************************
** Function name:       PIOINT1_IRQHandler
** Descriptions:        S2ӦжϷһ
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void PIOINT1_IRQHandler  (void)
{
    uint16_t  i      = 0;    
    
    dellayxms(10); 
    while(!(LPC_GPIO1->DATA & (1ul << 2)));    	    	    	    	/*  ȴɿ                */

    for(i = 0; i < 50; i++) {
        ucTxbuf[i] = i;
    }
    uiByteNum = 10; 
    uiMs = 2;                                                           /* ʹܷ                 */

    LPC_GPIO1->IC |= (1ul << 2);                                        /*  жϱ־                */

}
/*********************************************************************************************************
** Function name:       KEY3_INT
** Descriptions:        жϳʼ
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void KEY3_INT (void)
{
    LPC_GPIO0->DIR &= ~ (1ul << 7);                                     /*  P0.7Ϊ              */
    LPC_GPIO0->IS   = 0x00;                                             /*  P0.7Ϊж              */
    LPC_GPIO0->IEV &= ~(1ul << 7);                                      /*  ½ж                  */
    LPC_GPIO0->IE  |= (1ul << 7);                                       /*  P0.7жϲ              */    	
    NVIC_EnableIRQ(EINT0_IRQn);                                         /* жϲʹ               */
    NVIC_SetPriority(EINT0_IRQn, 2);    
    LPC_GPIO0->IC |= (1ul << 7);                                        /*  жϱ־                */
}
/*********************************************************************************************************
** Function name:       PIOINT0_IRQHandler
** Descriptions:        S3жϷ
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void PIOINT0_IRQHandler  (void)
{
	uint8_t reg = 0;
    UPwr++;
    if (UPwr > 7) {
    	UPwr = 0;
    }    
	reg = DEF_TXPARAM | RF_TX_FC_200 | UPwr<<1 | RF_TX_ZERO_IF_OFF; 
    
	while(!(LPC_GPIO0->DATA & (1ul << 7))){
		;   
	}		
	/*  ȴɿ                */
    dellayxms(10); 
    LPC_GPIO0->IC |= (1ul << 7);                                        /*  жϱ־               */
	WriteRegister(26,reg);	
	LED_Show(UPwr);
}
/*********************************************************************************************************
** Function name:       DisableIRQ
** Descriptions:        رж
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void DisableIRQ (void)
{
    NVIC_DisableIRQ(EINT0_IRQn);    	          /* ʧжϣΪжжģSPIʱ  */
    NVIC_DisableIRQ(EINT1_IRQn);
}
/*********************************************************************************************************
** Function name:       EnableIRQ
** Descriptions:        ָж
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void EnableIRQ (void)
{
    NVIC_EnableIRQ(EINT0_IRQn);                                         /* ָж                     */
    NVIC_EnableIRQ(EINT1_IRQn);      
}
/*********************************************************************************************************
** Function name:       main
** Descriptions:        Ӧú
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
int main(void)
{
	uint8_t   ReturnFlag            = 0;    
	uint8_t   j                     = 0;
	uint16_t  i                     = 0;    	
	uint16_t  temp                  = 0x5f;    
	uint8_t   tempbuf[PACK_LENGTH]  = {0};
	/* ϵͳʼ11.0592MHz   */ 
	SystemInit();                                                         	    
	LPC_SYSCON->SYSAHBCLKCTRL |= (1 << 6);   
	/* ʼLED                    */
	LED_INIT();   
	/* ʼUART                   */ 
	uartInit(); 
	/* ʼťS3ж;Ӧ      */
	KEY3_INT();  
	/* ʼťS2ж               */
	KEY2_INT();   
	/* ʼSX1212                   */	
	InitRFChip();   
	/* زƵ                 */ 	   
	Freq_Set(433000);
	SetRFMode(RF_RECEIVER);
	LED_Show(0x18);
	while (1) {  
		/*    */ 
		/*  յDIO0   */   
		if (IRQ1_READ()) { 
			ReceiveRfFrame(&ucRxbuf[0], &j, &ReturnFlag);
			SetRFMode(RF_RECEIVER);
			if(j > 0) {
				/*  ݴӴڷͳȥ         */
				for (temp = 0; temp < j; temp++) {
					uartSendByte(ucRxbuf[temp]);                        	    	
				}
				/*  յݼ1            */ 	    
				led++;
				led = led % 128; 
				LED_Show(led);
			}    	    
		}
		/*    */  
		/*  ߽ճʱ      */
		if(uiByteNum >= (PACK_LENGTH-4) || uiMs == 1) {                            
			/*  ʧж,ֹSPIʱ     */
			DisableIRQ();   
			/*  ʧUARTж                 */
			NVIC_DisableIRQ(UART_IRQn);                                 
			
			for (i = 0; i < uiByteNum; i++) {
			/*  Ѵڻݶ    */ 
				tempbuf[i] = ucTxbuf[i];                                  
			}    	      
			/*  ݱ־          */
			uiByteNum = 0;   
			/*  ʹUARTж                */
			NVIC_EnableIRQ(UART_IRQn);
			LED_Show(0x80);    	
			/*  һ֡                */
			SendRfFrame(&tempbuf[0], i, &ReturnFlag);
			SetRFMode(RF_RECEIVER); 
			/*  ָж                */
			EnableIRQ();                                              
			LED_Show(led);
			uiMs = 0;    
			//ucsleep = 1;    
		}
		/*           */
		if (ucsleep == 1) {
			SetRFMode(RF_SLEEP);                                            
			ucsleep = 0;
		}
		if (uiByteNum > 0) {
			dellayxms(1);
			if(uiMs > 0) {
				/*  봮жϣuiMs=3ʱ3msûյѻ淢ͳȥ         */
				uiMs--;                                                  
			}   
		}    	    
	}
}

/*********************************************************************************************************
  End Of File
*********************************************************************************************************/
